#include "IDispatchWrapper.hpp"
#include <atlbase.h>
#include <atlconv.h>

// IuWFNg̑ΉƂ邽߂̃}bsO
// Ƃ肠̃NXɕĂƂ static ێőΉ

#pragma warning(disable: 4786)
#include <map>
using namespace std;
static map<ttstr,int> methodMap;
static map<int,ttstr> methodIdMap;

int
IDispatchWrapper::getAtom(const tjs_char *name)
{
	ttstr atomName(name);
	map<ttstr,int>::const_iterator n = methodMap.find(atomName);
	if (n != methodMap.end()) {
		return n->second;
	}
	int ret = methodMap.size();
	methodMap[atomName] = ret;
	methodIdMap[ret] = atomName;
	return ret;
}

const tjs_char *
IDispatchWrapper::getName(int atom)
{
	map<int,ttstr>::const_iterator n = methodIdMap.find(atom);
	if (n != methodIdMap.end()) {
		return n->second.c_str();	
	}
	return NULL;
}

IDispatchWrapper::IDispatchWrapper(iTJSDispatch2 *obj) 
{
	refCount = 1;
	this->obj = obj;
}

IDispatchWrapper::~IDispatchWrapper()
{
	obj->Release();
}

//----------------------------------------------------------------------------
// IUnknown 

HRESULT STDMETHODCALLTYPE
IDispatchWrapper::QueryInterface(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject) {
	if (riid == IID_IUnknown || riid == IID_IDispatch) {
		if (ppvObject == NULL)
			return E_POINTER;
		*ppvObject = this;
		AddRef();
		return S_OK;
	} else {
		*ppvObject = 0;
		return E_NOINTERFACE;
	}
}

ULONG STDMETHODCALLTYPE
IDispatchWrapper::AddRef()
{
	refCount++;
	return refCount;
}
	
ULONG STDMETHODCALLTYPE
IDispatchWrapper::Release()
{
	int ret = --refCount;
	if (ret <= 0) {
		delete this;
		ret = 0;
	}
	return ret;
}

/**
 * VARIANT  tTJSVariant 擾
 * @param variant ϊ
 * @return ϊ
 */
tTJSVariant *
IDispatchWrapper::getVariant(VARIANT &variant)
{
	USES_CONVERSION;
	switch (variant.vt) {
	case VT_I8:
		return new tTJSVariant(variant.llVal);
	case VT_I4:
		return new tTJSVariant((tjs_int32)variant.lVal);
	case VT_UI1:
		return new tTJSVariant((tjs_int32)variant.bVal);
	case VT_I2:
		return new tTJSVariant((tjs_int32)variant.iVal);
	case VT_R4:
		return new tTJSVariant(variant.fltVal);
	case VT_R8:
		return new tTJSVariant(variant.dblVal);
	case VT_BOOL:
		return new tTJSVariant(variant.boolVal == VARIANT_TRUE);
	case VT_BSTR:
		return new tTJSVariant(OLE2CW(variant.bstrVal));
	case VT_BYREF | VT_I8:
		return new tTJSVariant(*variant.pllVal);
	case VT_BYREF | VT_I4:
		return new tTJSVariant((tjs_int32)*variant.plVal);
	case VT_BYREF | VT_UI1:
		return new tTJSVariant((tjs_int32)*variant.pbVal);
	case VT_BYREF | VT_I2:
		return new tTJSVariant((tjs_int32)*variant.piVal);
	case VT_BYREF | VT_R4:
		return new tTJSVariant(*variant.pfltVal);
	case VT_BYREF | VT_R8:
		return new tTJSVariant(*variant.pdblVal);
	case VT_BYREF | VT_BOOL:
		return new tTJSVariant(*variant.pboolVal == VARIANT_TRUE);
	case VT_BYREF | VT_BSTR:
		return new tTJSVariant(OLE2CW(*variant.pbstrVal));
	case (VT_BYREF | VT_VARIANT):
		return getVariant(*variant.pvarVal);
	}
	// ǂłȂ
	return new tTJSVariant();
}

/**
 * tTJSVariant  VARIANT Ɋi[
 * @param result i[
 * @param variant i[
 */
void
IDispatchWrapper::storeVariant(VARIANT *result, tTJSVariant &variant)
{
	VariantClear(result);
	switch (variant.Type()) {
	case tvtVoid:
		V_VT(result) = VT_NULL;
		break;
	case tvtObject:
		V_VT(result)       = VT_DISPATCH;
		V_DISPATCH(result) = new IDispatchWrapper(variant.AsObject());
		break;
	case tvtString:
		V_VT(result) = VT_BSTR;
		V_BSTR(result) = W2BSTR(variant.GetString());
		break;
//	case tvtOctet:
//		V_VT(result) = VT_ARRAY | VT_VARIANT;
//		V_ARRAY(result) = psa;
//		break;
	case tvtInteger:
		V_VT(result) = VT_I4;
		V_I4(result) = (tjs_int)variant;
		break;
	case tvtReal:
		V_VT(result) = VT_R8;
		V_I4(result) = (double)variant;
		break;
	}
}

//-------------------------------------------------------------------
// IDispatch 

HRESULT
IDispatchWrapper::GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgdispid)
{
	UINT i;
	for (i=0; i<cNames; i++) {
		// XXX ݃`FbNłȂȁ[
		USES_CONVERSION;
		rgdispid[i] = getAtom(OLE2CW(rgszNames[i]));
	}
	return S_OK;
}

HRESULT
IDispatchWrapper::Invoke(DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags,
						 DISPPARAMS* pdispparams, VARIANT* pvarResult, EXCEPINFO* pexcepinfo, UINT* puArgErr)
{
	const tjs_char *memberName = getName(dispidMember);
	
	// p[^ݒ
	int      argc = pdispparams->cArgs;
	VARIANT *argv = pdispparams->rgvarg;

	// vpeB擾
	if ((wFlags & DISPATCH_PROPERTYGET)) {
		tTJSVariant result;
		obj->PropGet(0, memberName, (tjs_uint32*)&dispidMember, &result, obj);
		if (pvarResult) {
			storeVariant(pvarResult, result);
		}
		return S_OK;
	}
	
	// vpeBݒ
	if ((wFlags & DISPATCH_PROPERTYPUT) && argc > 0) {
		tTJSVariant *arg = getVariant(argv[0]);
		obj->PropSet(0, memberName, (tjs_uint32*)&dispidMember, arg, obj);
		return S_OK;
	}
	
	// \bhĂяo
	
	// ϊ
	tTJSVariant **args = new tTJSVariant*[argc];
	for (int i=0;i<argc;i++) {
		args[i] = getVariant(argv[argc - i - 1]);
	}
	
	// IuWFNgsp̃XNvgNX𐶐
	tTJSVariant result;
	obj->FuncCall(0, memberName, (tjs_uint32*)&dispidMember, &result, argc, args, obj);
	if (pvarResult) {
		storeVariant(pvarResult, result);
	}
	
	// j
	for (i=0;i<argc;i++) {
		delete args[i];
	}
	
	return S_OK;
}
