#ifndef _idispatch_wrapper_
#define _idispatch_wrapper_

#include <windows.h>
#include "tp_stub.h"

/**
 * iTJSDispatch2 p IDispatch bp[
 */
class IDispatchWrapper : public IDispatch
{
public:
	static int getAtom(const tjs_char *name);
	static const tjs_char *getName(int atom);
	static tTJSVariant *getVariant(VARIANT &variant);
	static void storeVariant(VARIANT *result, tTJSVariant &variant);
	
protected:
	int refCount;
	iTJSDispatch2 *obj;

public:
	IDispatchWrapper(iTJSDispatch2 *obj);
	~IDispatchWrapper();
	
	//----------------------------------------------------------------------------
	// IUnknown 
public:
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void __RPC_FAR *__RPC_FAR *ppvObject);
	ULONG STDMETHODCALLTYPE AddRef();
	ULONG STDMETHODCALLTYPE Release();
	
	//-------------------------------------------------------------------
	// IDispatch 
public:
	STDMETHOD (GetTypeInfoCount) (UINT* pctinfo) { return	E_NOTIMPL; }
	STDMETHOD (GetTypeInfo) (UINT itinfo, LCID lcid, ITypeInfo** pptinfo) {	return	E_NOTIMPL; }
	STDMETHOD (GetIDsOfNames) (REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgdispid);
	STDMETHOD (Invoke) (DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult, EXCEPINFO* pexcepinfo, UINT* puArgErr);
};

#endif
